<?php

/*
RBookmarks
Copyright (C) 2001-2002  Ragnar Ouchterlony

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

require("include/common_functions.php");

function print_category_to_selection( $ccat )
{
  global $all_children;

  if( $ccat->id != 0 )
    {
      $name_with_parents = htmlspecialchars($ccat->get_name_with_parents());
      echo "         <option label=\"$name_with_parents)\" value=\"$ccat->id\">".
        "$name_with_parents</option>\n";
    }
}

function add_id_to_array( $ccat )
{
  global $all_children;

  array_push( $all_children, $ccat->id );
}

{
  connect_database();
  create_categories();

  if( !$_POST['what'] )
    $_POST['what'] = 'nothing';

  $force_category_update = false;
  $change_message = '';
  switch( $_POST['what'] )
    {
    case 'add':
      {
        if( is_null($_POST['category']) )
          $_POST['category'] = 0;
        if( empty($_POST['name']) )
          error("Du mste ange ett namn fr att addera en kategori.");

        if( $_POST['category'] == 0 )
          {
            $parent_value = "NULL";
            $parent_comparison = "parent IS NULL";
          }
        else
          {
            $parent_value = $_POST['category'];
            $parent_comparison = "parent=$parent_value";
          }

        $query_result = mysql_query( "SELECT * FROM category ".
                                     "WHERE name='".$_POST['name'].
                                     "' AND $parent_comparison" );
        if( mysql_num_rows( $query_result ) > 0 )
          error("Kategorin du frskte addera fanns redan.");

        mysql_query( "INSERT INTO category SET name='".
                     $_POST['name']."', parent=$parent_value" )
          or error("Misslyckades med att addera lnk.");

        if( $_POST['category'] == 0 )
          $change_message = "Adderade kategori '".$_POST['name']."' som '".$_POST['name']."'";
        else
          $change_message = "Adderade kategori '".$_POST['name']."' som '".
            $category_hierarchy[ $_POST['category'] ]->get_name_with_parents()."'";

        $force_category_update = true;
      }
      break;

    case 'change':
      {
        if( empty($name) )
          error("Kan inte ndra namn p kategori utan ett nytt namn angivet.");
        if( is_null($_POST['category']) or $_POST['category'] == 0 )
          error("Kan inte ndra namn p den kategorin.");

        $query_result = mysql_query( "SELECT id FROM category WHERE id=".$_POST['category'] );
        if( mysql_num_rows( $query_result ) != 1 )
          error("Kategorin som skulle ndras fanns inte.");

        $old_name = $category_hierarchy[$_POST['category']]->get_name_with_parents();
        mysql_query( "UPDATE category SET name='".
                     $_POST['name']."' WHERE id=".$_POST['category'] )
          or error("Fel vid uppdatering av kategori '$old_name'.");

        $change_message = "ndrade namn p kategori '$old_name' till '".$_POST['name']."'.";
        $force_category_update = true;
      }
      break;

    case 'move':
      {
        if( is_null($_POST['category']) or $_POST['category'] == 0 )
          error("Kan inte flytta p den kategorin.");
        if( is_null($_POST['extra_category']) )
          $_POST['extra_category'] = 0;

        $query_result = mysql_query( "SELECT id FROM category WHERE id=".$_POST['category'] );
        if( mysql_num_rows( $query_result ) != 1 )
          error("Kategorin som skulle flyttas fanns inte.");

        if( $_POST['extra_category'] == 0 )
          {
            $ec_value = "NULL";
            $ec_comp_str = "parent IS NULL";
          }
        else
          {
            $ec_value = $_POST['extra_category'];
            $ec_comp_str = "parent=$ec_value";
            $query_result = mysql_query( "SELECT id FROM category WHERE id=".
                                         $_POST['extra_category'] );
            if( mysql_num_rows( $query_result ) != 1 )
              error("Kunde inte hitta den nya frldern fr kategorin som skall flyttas.");
          }

        $ccat = $category_hierarchy[ $_POST['category'] ];
        $eccat = $category_hierarchy[ $_POST['extra_category'] ];

        $query_result = mysql_query( "SELECT id FROM category WHERE ".
                                     "name='$ccat->name' AND parent=".
                                     $_POST['extra_category'] );
        if( mysql_num_rows( $query_result ) > 0 )
          error("Det fanns redan en kategori med det namnet och den frldern.");

        mysql_query("UPDATE category SET parent=$ec_value WHERE id=".$_POST['category'])
          or error("Fel vid flytt av kategori.");

        $change_message = "Flyttade kategori '".$ccat->get_name_with_parents().
          "' till '".$eccat->get_name_with_parents()."'";
        $force_category_update = true;
      }
      break;

    case 'remove':
      {
        if( empty($_POST['category']) or $_POST['category'] == 0 )
          error("Kan inte ta bort den kategorin.");

        $query_result = mysql_query( "SELECT id FROM category WHERE id=".$_POST['category'] );
        if( mysql_num_rows( $query_result ) != 1 )
          error("Kategorin som skulle tas bort fanns inte.");

        $cat_name_with_parents = $category_hierarchy[$_POST['category']]->get_name_with_parents();
        $all_children = array();
        $category_hierarchy[$_POST['category']]->do_and_propagate_to_children( "add_id_to_array" );
        $cat_str = '(';
        foreach( $all_children as $id )
          {
            $cat_str .= strval($id) . ",";
          }
        $cat_str = substr($cat_str,0,-1) . ')';

        mysql_query( "DELETE FROM category WHERE id IN $cat_str" )
          or error("Fel vid borttagande av kategori '$cat_name_with_parents'.");
        mysql_query( "DELETE FROM link_category WHERE lc_category IN $cat_str" )
          or error("Fel vid borttagande av kopplingar till kategori '$cat_name_with_parents'.");
        $change_message = "Tog bort kategori '$cat_name_with_parents' och dess underkategorier.";
        $force_category_update = true;
      }
      break;

    default:
      break;
    }

  create_categories( $force_category_update );

  render_page_start( $bookmark_title . ' - Kategorier' );

  if( !empty($change_message) )
    echo "  <tr><td colspan=\"2\" class=\"changestring\">$change_message</td></tr>\n";
  echo "  <tr>\n";
  echo "   <td colspan=\"2\" class=\"linkcolumn\" valign=\"top\">\n";
  echo "    <form action=\"addcategory.php\" method=\"post\">\n";
  echo "     <table width=\"100%\" cellspacing=\"0\" summary=\"Manipulera kategorier\">\n";
  echo "      <tr><td colspan=\"6\" class=\"header\">".
    "Lgg till / ndra / ta bort kategori</td></tr>\n";

  echo "      <tr>\n";
  echo "       <td class=\"addlink\" style=\"text-align: right;\">Namn:</td>\n";
  echo "       <td class=\"addlink\" style=\"text-align: left;\">\n";
  echo "        <input type=\"text\" name=\"name\" size=\"21\">\n";
  echo "       </td>\n";
  echo "       <td class=\"addlink\" style=\"text-align: left;\">\n";
  echo "        <input type=\"radio\" name=\"what\" ".
    "value=\"add\" checked>&nbsp;Addera&nbsp;kategori<br>\n";
  echo "        <input type=\"radio\" name=\"what\" ".
    "value=\"change\">&nbsp;ndra&nbsp;namn&nbsp;p&nbsp;kategori<br>\n";
  echo "        <input type=\"radio\" name=\"what\" ".
    "value=\"move\">&nbsp;Flytta&nbsp;kategori<br>\n";
  echo "        <input type=\"radio\" name=\"what\" ".
    "value=\"remove\">&nbsp;Ta&nbsp;bort&nbsp;kategori\n";
  echo "       </td>\n";
  echo "       <td class=\"addlink\" style=\"text-align: right;\">\n";
  echo "        Kategori:\n";
  echo "        <br><br>\n";
  echo "        Extra kategori:\n";
  echo "       </td>\n";
  echo "       <td class=\"addlink\" style=\"text-align: left;\">\n";

  echo "        <select name=\"category\">\n";
  echo "         <option label=\"none\" value=\"0\">Ingen</option>\n";

  $category_hierarchy[0]->do_and_propagate_to_children( "print_category_to_selection" );

  echo "        </select>\n";

  echo "        <br><br>\n";

  echo "        <select name=\"extra_category\">\n";
  echo "         <option label=\"none\" value=\"0\">Ingen</option>\n";

  $category_hierarchy[0]->do_and_propagate_to_children( "print_category_to_selection" );

  echo "        </select>\n";

  echo "       </td>\n";
  echo "       <td class=\"addlink\" style=\"text-align: center;\">\n";
  echo "        <input type=\"submit\" value=\"Skicka\"><br><br>\n";
  echo "        <input type=\"reset\" value=\"Rensa formulr\">\n";
  echo "       </td>\n";
  echo "      </tr>\n";
  echo "     </table>\n";
  echo "    </form>\n";
  echo "   </td>\n";
  echo "  </tr>\n";

  render_page_end();
}

?>
