<?php

/*
RBookmarks
Copyright (C) 2001-2002  Ragnar Ouchterlony

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

require("include/common_functions.php");

function print_category_to_selection( $ccat )
{
  global $all_children, $found_link_info;

  if( $ccat->id != 0 )
    {
      $name_with_parents = htmlspecialchars($ccat->get_name_with_parents());
      echo "         <option label=\"$name_with_parents\" value=\"$ccat->id\"";
      if( $found_link_info != -1 &&
          in_array( $ccat->id, $found_link_info['categories'] ) )
        echo " selected";
      echo ">".$name_with_parents."</option>\n";
    }
}

{
  connect_database();
  create_categories();

  create_categories( $force_category_update );

  $force_category_update = false;
  $change_message = '';
  $found_link_info = -1;

  $INPUT = array_merge( $_GET, $_POST );

  if( !empty($INPUT['what']) )
    {
      if( is_null( $INPUT['categories'] ) )
        $INPUT['categories'] = array();

      $description_info = -1;
      if( !empty($INPUT['description']) )
        {
          $q_result = mysql_query( "SELECT * FROM link WHERE description='".
                                   $INPUT['description']."'" );
          $n_rows = mysql_num_rows( $q_result );
          if( $n_rows == 1 )
            $description_info = mysql_fetch_array( $q_result );
          elseif( $n_rows > 1 )
            error("Inkonsistent databas.");
        }

      $url_info = -1;
      if( !empty($INPUT['url']) )
        {
          $q_result = mysql_query( "SELECT * FROM link WHERE url='".$INPUT['url']."'" );
          $n_rows = mysql_num_rows( $q_result );
          if( $n_rows == 1 )
            $url_info = mysql_fetch_array( $q_result );
          elseif( $n_rows > 1 )
            error("Inkonsistent databas.");
        }

      switch( $INPUT['what'] )
        {
        case 'add':
          {
            if( empty($INPUT['url']) || empty($INPUT['description']) )
              error("Kan inte lgga till lnk med tom beskrivning eller url.");

            if( $description_info != -1 )
              error("Kan inte lgga till lnken. Beskrivningen fanns redan i databasen.");
            if( $url_info != -1 )
              error("Kan inte lgga till lnken. URL:en fanns redan i databasen.");

            if( count($INPUT['categories']) == 0 )
              error("Du har inte valt ngra kategorier. Gr det innan du kan addera lnken.");

            mysql_query("INSERT INTO link SET url='".$INPUT['url'].
                        "', description='".$INPUT['description']."'")
              or error("Fel vid adderande av lnk.");
            $new_id = mysql_insert_id();
            if( $new_id == 0 )
              error("Fel vid adderande av lnk. Kunde inte f id fr lnken som just sattes in");

            $add_in_lc_query = "INSERT INTO link_category (lc_link, lc_category) VALUES ";
            foreach( $INPUT['categories'] as $cat )
              $add_in_lc_query .= "( $new_id, $cat ),";
            $add_in_lc_query = substr($add_in_lc_query,0,-1);
            mysql_query( $add_in_lc_query )
              or error("Fel vid adderandet av lnk: Kunde inte stta in kategorier i databasen.");
            $change_message = "Adderade lnk med beskrivningen '".
              $INPUT['description']."' och url '".$INPUT['url']."'.";
          }
          break;

        case 'find':
          {
            if( empty($INPUT['description']) && empty($INPUT['url']) )
              error("Mste ha antingen url eller beskrivning fr att hitta en lnk.");

            $found_link_info = -1;
            if( empty($INPUT['description']) )
              {
                if( $url_info == -1 )
                  error("Lnken med url '".$INPUT['url']."' kunde inte hittas.");

                $found_link_info = $url_info;
              }
            elseif( empty($INPUT['url']) )
              {
                if( $description_info == -1 )
                  error("Lnken med beskrivning '".
                        $INPUT['description']."' kunde inte hittas.");

                $found_link_info = $description_info;
              }
            else
              {
                if( $description_info == -1 || $url_info == -1 )
                  error("Lnken med beskrivning '".$INPUT['description']."' och url '".
                        $INPUT['url']."' hittades inte i databasen.");
                if( $description_info['id'] != $url_info['id'] )
                  error("Beskrivningen '".$INPUT['description']."' och url:en '".
                        $INPUT['url']."' r inte samma lnk.");

                $found_link_info = $description_info;
              }

            $found_link_info['categories'] = array();
            $q_result = mysql_query("SELECT lc_category FROM link_category WHERE lc_link=".$found_link_info['id']);
            while( $row = mysql_fetch_array( $q_result ) )
              array_push( $found_link_info['categories'], $row['lc_category'] );

            $change_message = "Hittade lnk med beskrivning '".
              $found_link_info['description']."' och url '".
              $found_link_info['url']."'.";
          }
          break;

        case 'change':
          {
            if( empty($INPUT['description']) || empty($INPUT['url']) )
              error("Kan inte ndra en lnk utan beskrivning och url.");

            if( $description_info == -1 && $url_info == -1 )
              error("Varken given beskrivning eller url hittades fr att ndra.");

            $update_info = -1;
            if( $description_info == -1 )
              {
                $update_info = $url_info;
                mysql_query( "UPDATE link SET description='".$INPUT['description'].
                             "' WHERE id=".$update_info['id'] )
                  or error("Fel vid uppdatering av beskrvining fr lnk med url '".
                           $INPUT['url']."'.");
                $change_message = "Uppdaterade lnken med url '".$INPUT['url']."'.";
              }
            elseif( $url_info == -1 )
              {
                $update_info = $description_info;
                mysql_query( "UPDATE link SET url='".$INPUT['url'].
                             "' WHERE id=".$update_info['id'] )
                  or error("Fel vid uppdatering av url fr lnk med ".
                           "beskrivning '".$INPUT['description']."'.");
                $change_message = "Uppdaterade lnken med beskrivning '".
                  $INPUT['description']."'.";
              }
            else
              {
                if( $description_info['id'] != $url_info['id'] )
                  error("Beskrivningen '".$INPUT['description']."' och url:en '".
                        $INPUT['url']."' r inte samma lnk och kan drfr inte ndras.");
                if( empty($INPUT['categories']) )
                  error("Finns ingenting att ndra");

                $update_info = $description_info;
                $change_message = "Uppdaterade lnken med beskrivning '".
                  $INPUT['description']."' och url '".$INPUT['url']."'.";
              }

            if( !empty($INPUT['categories']) )
              {
                $earlier_categories = array();
                $q_result = mysql_query("SELECT lc_category FROM link_category ".
                                        "WHERE lc_link=".$update_info['id']);
                $del_counter = 0;
                $del_lc_query = "DELETE FROM link_category WHERE lc_link=".
                  $update_info['id']." AND lc_category IN (";
                while( $row = mysql_fetch_array( $q_result ) )
                  {
                    $cid = $row['lc_category'];
                    array_push( $earlier_categories, $cid );
                    if( !in_array( $cid, $INPUT['categories'] ) )
                      {
                        $del_counter++;
                        if( $del_counter > 1 )
                          $del_lc_query .= ',';
                        $del_lc_query .= $cid;
                      }
                  }
                $del_lc_query .= ')';

                $ins_counter = 0;
                $ins_lc_query = "INSERT INTO link_category (lc_link, lc_category) VALUES ";
                foreach( $INPUT['categories'] as $cid )
                  {
                    if( !in_array( $cid, $earlier_categories ) )
                      {
                        $ins_counter++;
                        if( $ins_counter > 1 )
                          $ins_lc_query .= ',';
                        $ins_lc_query .= '('.$update_info['id'].", $cid)";
                      }
                  }

                if( $del_counter > 0 )
                  mysql_query( $del_lc_query )
                    or error("Fel vid ndring av lnk: Kunde inte ta bort kategorier.");
                if( $ins_counter > 0 )
                  mysql_query( $ins_lc_query )
                    or error("Fel vid ndring av lnk: Kunde inte lgga till kategorier.");
              }
          }
          break;

        case 'remove':
          {
            if( empty($INPUT['description']) && empty($INPUT['url']) )
              error("Kan inte ta bort en lnk utan beskrivning eller url.");

            $remove_info = -1;
            if( empty($INPUT['description']) )
              {
                if( $url_info == -1 )
                  error("Lnken med url '".$INPUT['url'].
                        "' fanns inte i databasen och kunde inte tas bort.");

                $remove_info = $url_info;
                $change_message = "Tog bort lnken med url '".$INPUT['url']."'.";
              }
            elseif( empty($INPUT['url']) )
              {
                if( $description_info == -1 )
                  error("Lnken med beskrivning '".$INPUT['description'].
                        "' fanns inte i databasen och kunde inte tas bort.");

                $remove_info = $description_info;
                $change_message = "Tog bort lnken med beskrivning '".
                  $INPUT['description']."'.";
              }
            else
              {
                if( $description_info == -1 || $url_info == -1 )
                  error("Lnken med beskrivning '".$INPUT['description']."' och url '".
                        $INPUT['url']."' fanns inte i databasen och kunde inte tas bort.");
                if( $description_info['id'] != $url_info['id'] )
                  error("Beskrivningen '".$INPUT['description']."' och url:en '".
                        $INPUT['url']."' r inte samma lnk ".
                        "och ingenting kunde drfr inte tas bort.");
                $remove_info = $description_info;
                $change_message = "Tog bort lnken med beskrivning '".
                  $INPUT['description']."' och url '".$INPUT['url']."'.";
              }

            mysql_query("DELETE FROM link WHERE id=".$remove_info['id'])
              or error("Fel vid borttagande av lnk.");
            mysql_query("DELETE FROM link_category WHERE lc_link=".$remove_info['id'])
              or error("Fel vid borttagande av kategorikopplingar till lnk.");
          }
          break;

        default:
          break;
        }
    }
  render_page_start( $bookmark_title . ' - Lnkadministration' );

  if( !empty($change_message) )
    echo "  <tr><td colspan=\"2\" class=\"changestring\">$change_message</td></tr>\n";
  echo "  <tr>\n";
  echo "   <td colspan=\"2\" class=\"linkcolumn\" valign=\"top\">\n";
  echo "    <form action=\"addlink.php\" method=\"post\">\n";
  echo "     <table width=\"100%\" cellspacing=\"0\" summary=\"Manipulera lnkar\">\n";
  echo "      <tr><td colspan=\"5\" class=\"header\">".
    "Lgg till / ndra / ta bort lnkar</td></tr>\n";

  echo "      <tr>\n";
  echo "       <td class=\"addlink\" style=\"text-align: right;\">Beskrivning:</td>\n";
  echo "       <td colspan=\"2\" class=\"addlink\" style=\"text-align: left;\">\n";
  echo "        <input type=\"text\" name=\"description\" size=\"42\" "
    ."value=\"".($found_link_info == -1 ? '' :
                 htmlspecialchars($found_link_info['description']))."\">\n";
  echo "       </td>\n";
  echo "       <td rowspan=\"2\" class=\"addlink\">\n";
  echo "        <input type=\"radio\" name=\"what\" ".
    "value=\"add\" checked>&nbsp;Addera&nbsp;lnk<br>\n";
  echo "        <input type=\"radio\" name=\"what\" ".
    "value=\"find\">&nbsp;Finn&nbsp;lnk<br>\n";
  echo "        <input type=\"radio\" name=\"what\" ".
    "value=\"change\">&nbsp;ndra&nbsp;lnk<br>\n";
  echo "        <input type=\"radio\" name=\"what\" ".
    "value=\"remove\">&nbsp;Ta&nbsp;bort&nbsp;lnk<br>\n";
  echo "       </td>\n";
  echo "       <td rowspan=\"3\" class=\"addlink\">\n";

  echo "        <select name=\"categories[]\" size=\"".
    $addlink_category_size."\" multiple>\n";

  $category_hierarchy[0]->do_and_propagate_to_children( "print_category_to_selection" );

  echo "        </select>\n";

  echo "       </td>\n";
  echo "      </tr>\n";
  echo "      <tr>\n";
  echo "       <td class=\"addlink\" style=\"text-align: right;\">URL:</td>\n";
  echo "       <td colspan=\"2\" class=\"addlink\" ".
    " style=\"text-align: left;\">\n";
  echo "        <input type=\"text\" name=\"url\" size=\"42\" ".
    " value=\"".($found_link_info == -1 ? '' :
                 htmlspecialchars($found_link_info['url']))."\">\n";
  echo "       </td>\n";
  echo "      </tr>\n";
  echo "      <tr>\n";
  echo "       <td class=\"addlink\"></td>\n";
  echo "       <td class=\"addlink\" style=\"text-align: center;\">\n";
  echo "        <input type=\"submit\" value=\"Skicka\">\n";
  echo "       </td>\n";
  echo "       <td class=\"addlink\" style=\"text-align: center;\">\n";
  echo "        <input type=\"reset\" value=\"Rensa formulr\">\n";
  echo "       </td>\n";
  echo "      </tr>\n";

  echo "     </table>\n";
  echo "    </form>\n";
  echo "   </td>\n";
  echo "  </tr>\n";
  render_page_end();
}

?>
