<?php
/*
RBookmarks
Copyright (C) 2001-2002  Ragnar Ouchterlony

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

require("include/common_functions.php");

function create_args_in_link( $theargs )
{
  $result = '';
  $mc = '?';
  foreach( $theargs as $name => $val )
    {
      $result .= $mc . $name . '=' . urlencode(strval($val));
      if( $mc == '?' )
        $mc = '&amp;';
    }
  return $result;
}

function print_dots( $num_dots )
{
  $str = "";
  for( $i=0; $i < $num_dots; $i++ )
    $str .= "&nbsp;";
  return $str;
}

function print_category( $ccat )
{
  global $ps;

  if( $ccat->id == 0 )
    return;

  $open_cat =
    ($ps->options->collapse_categories && in_array( $ccat->id, $ps->cc_array->the_array )) ||
    (!$ps->options->collapse_categories && !in_array( $ccat->id, $ps->cc_array->the_array ));

  $tdclass = "category";
  if( $ccat->id == $ps->current_category )
    $tdclass = "currentcategory";

  $padding = 1 + 26*$ccat->count_ancestors();
  $num_dots = max(0,2*$ccat->count_ancestors()-1);
  $dot_str = "";

  if( !empty($ccat->children) && !$ps->options->static )
    {
      $cc_new_array = array();
      if( $open_cat )
        {
          $padding += 5;
          $cc_new_array = array_diff( $ps->cc_array->the_array, array( $ccat->id ) );
        }
      else
        {
          $cc_new_array = array_merge( $ps->cc_array->the_array, array( $ccat->id ) );
          sort( $cc_new_array );
        }

      if( $ps->options->dots )
        $dot_str = print_dots( $num_dots );
      echo "     <tr><td class=\"".$tdclass."\" ".
        "style=\"padding-left: ".strval($padding)."\">".$dot_str."\n";

      echo "      <a href=\"".
        create_args_in_link( array( 'category' => $ps->current_category,
                                    'cc_str' => implode( '.', $cc_new_array ),
                                    'filter' => $ps->filter_array->get_as_string(),
                                    'options' => $ps->options->as_string() ) ).
        "\" class=\"plminlink\">";
      $dot_str = "";

      if( $open_cat )
        echo "-</a>\n";
      else
        echo "+</a>\n";
    }
  else
    {
      if( $ps->options->dots )
        $dot_str = print_dots( $num_dots + 2 );
      echo "     <tr><td class=\"".$tdclass."\" ".
        "style=\"padding-left: ".strval($padding+13)."\">".$dot_str."\n";
    }

  if( !$ps->options->static )
    {
      echo "      ".
        "<a href=\"".
        create_args_in_link( array( 'category' => $ccat->id,
                                    'cc_str' => $ps->cc_array->get_as_string(),
                                    'filter' => $ps->filter_array->get_as_string(),
                                    'options' => $ps->options->as_string() ) ).
        "\" class=\"categorylink\">".
        str_replace( " ", "&nbsp;", htmlspecialchars($ccat->name) )."</a>";

      if( $ps->options->use_filters )
        {
          $filter_new_array = array();
          if( in_array( $ccat->id, $ps->filter_array->the_array ) )
            {
              $style = " style=\"text-decoration: line-through\"";
              $filter_new_array = array_diff( $ps->filter_array->the_array,
                                              array( $ccat->id ) );
            }
          else
            {
              $style = '';
              $filter_new_array = array_merge( $ps->filter_array->the_array,
                                               array( $ccat->id ) );
              sort( $filter_new_array );
            }

          echo "&nbsp;<a href=\"".
            create_args_in_link( array( 'category' => $ps->current_category,
                                        'cc_str' => $ps->cc_array->get_as_string(),
                                        'filter' => implode( '.', $filter_new_array ),
                                        'options' => $ps->options->as_string() ) ).
            "\" class=\"filterlink\"$style>".
            "[filter]</a>";
        }
      echo "\n";
    }
  else
    {
      echo "      ".
        "<a href=\"".
        change_to_filename( htmlspecialchars($ccat->get_name_with_parents()) ).
        "\" class=\"categorylink\">".
        str_replace( " ", "&nbsp;", htmlspecialchars($ccat->name) )."</a>\n";
    }

  echo "     </td></tr>\n";
}

function is_visible( $ccat )
{
  global $ps;

  $open_cat =
    ($ps->options->collapse_categories && in_array( $ccat->parent, $ps->cc_array->the_array )) ||
    (!$ps->options->collapse_categories && !in_array( $ccat->parent, $ps->cc_array->the_array ));

  return ($ccat->is_top() || $open_cat);
}

function add_id_to_array( $ccat )
{
  global $all_children;

  array_push( $all_children, $ccat->id );
}

{

  connect_database();
  create_categories();

  if( $_COOKIE['RBookmarksState'] )
    $ps = unserialize( stripslashes( $_COOKIE['RBookmarksState'] ) );
  else
    $ps = new PageState;

  if( array_key_exists( 'category', $_GET ) )
    $ps->set_new_category( $_GET['category'] );

  if( array_key_exists( 'options', $_GET ) )
    $ps->set_new_options( $_GET['options'] );

  if( array_key_exists( 'cc_str', $_GET ) )
    $ps->set_new_cc_str( $_GET['cc_str'] );

  if( array_key_exists( 'filter', $_GET ) )
    $ps->set_new_filter_str( $_GET['filter'] );

  if( $_GET['save_state'] == 1 || $ps->options->always_save_state )
    {
      $result = setcookie( $cookiename,
                           serialize( $ps ),
                           time() + $default_cookie_expiration,
                           $sitepath );
    }

  render_page_start( $bookmark_title . ' - ' .
                     $category_hierarchy[ $ps->current_category ]->get_name_with_parents() );

  echo "  <tr>\n";
  echo "   <td class=\"catcolumn\" valign=\"top\">\n";
  echo "    <table class=\"cattable\" width=\"100%\" summary=\"Alla olika visade kategorier\">\n";
  echo "     <tr><td class=\"header\">Kategorier</td></tr>\n";

  $category_hierarchy[0]->do_and_propagate_to_children( "print_category", true, "is_visible" );

  echo "    </table>\n";
  echo "   </td>\n";

  $all_children = array();
  if( $ps->options->include_subcategories )
    {
      $category_hierarchy[ $ps->current_category ]->
        do_and_propagate_to_children( "add_id_to_array" );
    }
  else
    {
      $all_children = array( $ps->current_category );
    }

  $query = "SELECT link.* FROM link,link_category WHERE".
    " link.id = link_category.lc_link".
    " AND link_category.lc_category in (".implode(",", $all_children).")";

  $no_links = false;
  if( $ps->options->use_filters && !$ps->filter_array->is_empty() )
    {
      $accepted_links = array();
      $first = true;
      foreach( $ps->filter_array->the_array as $id )
        {
          $filter_query = "SELECT link.id FROM link,link_category WHERE".
            " link.id = link_category.lc_link".
            " AND link_category.lc_category = $id";
          $filter_result = mysql_query( $filter_query );
          $fal = array();
          while( $frow = mysql_fetch_array( $filter_result ) )
            $fal[] = $frow['id'];

          if( $first )
            {
              $accepted_links = $fal;
              $first = false;
            }
          else
            {
              $accepted_links = array_intersect( $accepted_links, $fal );
            }
        }

      if( empty($accepted_links) )
        $no_links = true;
      else
        $query .= " AND link.id in (".implode(",", $accepted_links).")";
    }

  if( !$no_links )
    {
      $query .= " ORDER BY link.description;";
      $query_result = mysql_query( $query );

      $max_length = 0;
      $real_result_set = array();
      while( $row = mysql_fetch_array( $query_result ) )
        {
          if( !array_key_exists( $row['id'], $real_result_set ) )
            {
              $real_result_set[ $row['id'] ] = $row;
              $max_length = max( $max_length, strlen( $row['description'] ) );
            }
        }

      $num_links = count($real_result_set); //mysql_num_rows( $query_result );

      if( $variable_links_per_row and $num_links != 0 )
        {
          $links_per_row = min( $max_links_per_row,
                                floor( $size_of_row / $max_length ) );
        }
    }

  echo "   <td class=\"linkcolumn\" valign=\"top\">\n";
  echo "    <table width=\"100%\" cellspacing=\"0\" summary=\"Alla hittade lnkar\">\n";
  echo "     <tr><td colspan=\"".$links_per_row."\" ".
    "class=\"header\">Lnkar - $num_links hittades</td></tr>\n";

  if( $no_links || $num_links == 0 )
    {
      echo "     <tr>\n";
      echo "      <td class=\"tlink\">Inga lnkar hittades!</td>\n";
      echo "     </tr>\n";
    }
  else
    {
      $place = -1;
      reset( $real_result_set );
      for( $counter = 0;
           $counter < ( floor($num_links / $links_per_row) +
                        ($num_links % $links_per_row == 0 ? 0 : 1) ) * $links_per_row;
           $counter++ )
        {
          if( $counter < $num_links )
            list(,$row) = each($real_result_set);
          else
            $row = null;

          $place = ($place + 1) % $links_per_row;

          if( $place == 0 )
            echo "     <tr>\n";

          echo "      <td class=\"tlink\">";

          if( is_null($row) )
            {
              echo "&nbsp;";
            }
          else
            {
              if( $ps->options->changelink )
                {
                  echo "<a href=\"addlink.php?what=find&amp;description=".
                    htmlentities(urlencode($row['description'])).
                    "&amp;url=".
                    htmlentities(urlencode($row['url'])).
                    "\" class=\"changelink\">[?]</a>&nbsp;";
                }

              echo "<a href=\"".$row['url']."\" class=\"alink\">".
                htmlspecialchars($row['description'])."</a>";
            }

          echo "</td>\n";

          if( $place == $links_per_row - 1 )
            echo "     </tr>\n";
        }
    }

  echo "    </table>\n";
  echo "   </td>\n";
  echo "  </tr>\n";

  $link_array = array( 'category' => $ps->current_category,
                       'cc_str' => $ps->cc_array->get_as_string(),
                       'options' => $ps->options->as_string() );

  if( !$ps->options->static && $ps->options->use_filters && !$ps->filter_array->is_empty() )
    {
      echo "  <tr>\n";
      echo "   <td colspan=\"2\" class=\"linkcolumn\" valign=\"top\">\n";
      echo "    <table width=\"100%\" cellspacing=\"0\" summary=\"Konfigurering av sidan\">\n";
      echo "     <tr><td class=\"header\">".
        "Filterinformation</td></tr>\n";

      foreach( $ps->filter_array->the_array as $id )
        {
          $new_array = array_diff( $ps->filter_array->the_array, array( $id ) );
          $link_array['filter'] = implode( '.', $new_array );
          echo "     <tr><td>".
            $category_hierarchy[$id]->get_name_with_parents().
            " <a href=\"".
            create_args_in_link( $link_array ).
            "\" class=\"filterlink\">[ta bort]</a>".
            "</td></tr>\n";
        }

      echo "    </table>\n";
      echo "   </td>\n";
      echo "  </tr>\n";
    }

  if( !$ps->options->static )
    {
      $nr_cols = 4;
      if( $ps->options->always_save_state )
        $nr_cols = 3;
      $colsize = round( 100 / $nr_cols );

      echo "  <tr>\n";
      echo "   <td colspan=\"2\" class=\"linkcolumn\" valign=\"top\">\n";
      echo "    <table width=\"100%\" cellspacing=\"0\" summary=\"Konfigurering av sidan\">\n";
      echo "     <tr><td colspan=\"$nr_cols\" class=\"header\">".
        "Konfigurering</td></tr>\n";

      if( $ps->options->use_filters )
        $link_array['filter'] = $ps->filter_array->get_as_string();
      else
        unset($link_array['filter']);

      echo "     <tr>\n";
      echo "      <td width=\"$colsize%\" class=\"toption\">\n";

      $new_options = $ps->options;
      $new_options->include_subcategories = !$new_options->include_subcategories;
      $link_array['options'] = $new_options->as_string();

      echo "       <a href=\"".
        create_args_in_link( $link_array ).
        "\" class=\"aoption\">".
        ( $ps->options->include_subcategories
          ? 'Exkludera underkategorier'
          : 'Inkludera underkategorier' ).
        "</a>\n";

      $new_options = $ps->options;
      $new_options->use_filters = !$new_options->use_filters;
      $link_array['options'] = $new_options->as_string();
      unset($link_array['filter']);

      echo "       <br><a href=\"".
        create_args_in_link( $link_array ).
        "\" class=\"aoption\">".
        ($ps->options->use_filters ? 'Anvnd inte filterfunktionalitet'
         : 'Anvnd filterfunktionalitet')."</a>\n";

      if( $ps->options->use_filters )
        $link_array['filter'] = $ps->filter_array->get_as_string();
      else
        unset($link_array['filter']);

      $link_array['cc_str'] = '';
      $new_options = $ps->options;
      $new_options->collapse_categories = false;
      $link_array['options'] = $new_options->as_string();

      echo "      <td width=\"33%\" class=\"toption\">\n";
      echo "       <a href=\"".
        create_args_in_link( $link_array ).
        "\" class=\"aoption\">Visa alla kategorier</a>\n";

      $new_options->collapse_categories = true;
      $link_array['options'] = $new_options->as_string();

      echo "       <br><a href=\"".
        create_args_in_link( $link_array ).
        "\" class=\"aoption\">Visa inga underkategorier</a>\n";

      echo "      </td>\n";

      $link_array['cc_str'] = $ps->cc_array->get_as_string();
      $new_options = $ps->options;
      $new_options->changelink = !$new_options->changelink;
      $link_array['options'] = $new_options->as_string();

      echo "      <td width=\"$colsize%\" class=\"toption\">\n";
      echo "       <a href=\"".
        create_args_in_link( $link_array ).
        "\" class=\"aoption\">".
        ($ps->options->changelink ? 'Visa inte ndra-lnk' : 'Visa ndra-lnk')."</a>\n";

      $new_options = $ps->options;
      $new_options->always_save_state = !$new_options->always_save_state;
      $link_array['options'] = $new_options->as_string();

      echo "       <br><a href=\"".
        create_args_in_link( $link_array ).
        "\" class=\"aoption\">".
        ($ps->options->always_save_state ? 'Kom ej ihg befintlig position'
         : 'Kom alltid ihg befintlig position')."</a>\n";
      echo "      </td>\n";

      if( !$ps->options->always_save_state )
        {
          $new_options = $ps->options;
          $link_array['options'] = $new_options->as_string();
          $link_array['save_state'] = 1;

          echo "      <td width=\"$colsize%\" class=\"toption\">\n";
          echo "       <a href=\"".
            create_args_in_link( $link_array ).
            "\" class=\"aoption\">".
            "Spara nuvarande position som frstahandsval</a>\n";
          echo "      </td>\n";
        }

      echo "     </tr>\n";
      echo "    </table>\n";
      echo "   </td>\n";
      echo "  </tr>\n";
    }

  render_page_end();
}

?>
