<?php

/* What categories should be open/closed in the static version? */
$static_cc_array = array( 23, 50, 63, 77, 183 );
/* Should the categories be open (0) or closed (1) by default in the static version? */
$static_cc = 1;
/* Should we include all subcategories in the static version? */
$static_isc = 1;
/* Should the static version display dots? */
$static_dots = 0;

function create_args_in_link( $theargs )
{
  $result = '';
  $mc = '?';
  foreach( $theargs as $name => $val )
    {
      $result .= $mc . $name . '=' . urlencode(strval($val));
      if( $mc == '?' )
        $mc = '&';
    }
  return $result;
}

function is_visible( $ccat )
{
  global $static_cc_array, $static_cc;

  $open_cat =
    ($static_cc == 1 && in_array( $ccat->parent, $static_cc_array )) ||
    ($static_cc == 0 && !in_array( $ccat->parent, $static_cc_array ));

  return ($ccat->is_top() || $open_cat);
}

function print_category( $ccat )
{
  global $hostbase, $static_cc_array, $static_cc, $static_isc, $static_dots;

  if( $ccat->id == 0 )
    return;

  $static_cc_str = implode( '.', $static_cc_array );

  echo
    "wget -q -O ".change_to_filename( htmlspecialchars($ccat->get_name_with_parents()) ).
    " \"".$hostbase."/".
    create_args_in_link( array( 'category' => $ccat->id,
                                'cc_str' => $static_cc_str,
                                'cc' => $static_cc,
                                'isc' => $static_isc,
                                'dots' => $static_dots,
                                'static' => 1 ) )."\"\n";
}

require("include/common_functions.php");

{
  echo "#!/bin/sh\n\n";

  connect_database();
  create_categories();

  $category_hierarchy[0]->do_and_propagate_to_children( "print_category", true, "is_visible" );
}

?>