<?php
/*
RBookmarks
Copyright (C) 2001-2002  Ragnar Ouchterlony

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software Foundation,
Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

require("include/common_functions.php");

function add_in_query( $searchstring )
{
  global $search_description, $search_url;

  $query = "(";
  if( $search_description )
    {
      $query .= "description LIKE '%$searchstring%'";
      if( $search_url )
        $query .= " OR ";
    }

  if( $search_url )
    $query .= "url LIKE '%$searchstring%'";

  $query .= ")";

  return $query;
}

{
  connect_database();
  create_categories();

  if( !is_null( $_GET['searchstring'] ) )
    {
      $searching = true;
      if( !is_string($_GET['match_type']) or
          ((strcmp($_GET['match_type'], 'and') != 0) and
           (strcmp($_GET['match_type'], 'or') != 0) and
           (strcmp($_GET['match_type'], 'phrase') != 0)) )
        $_GET['match_type'] = 'and';
      if( !is_string($_GET['ud']) or
          ((strcmp($_GET['ud'], 'description') != 0) and
           (strcmp($_GET['ud'], 'url') != 0) and
           (strcmp($_GET['ud'], 'both') != 0)) )
        $_GET['ud'] = 'description';

      $search_description = false;
      $search_url = false;
      if( strcmp($_GET['ud'], 'description') == 0 or strcmp($_GET['ud'], 'both') == 0 )
        $search_description = true;
      if( strcmp($_GET['ud'], 'url') == 0 or strcmp($_GET['ud'], 'both') == 0 )
        $search_url = true;
    }
  else
    {
      $searching = false;
    }

  render_page_start( $bookmark_title . ' - Skning' );

  echo "  <tr>\n";
  echo "   <td colspan=\"2\" class=\"linkcolumn\" valign=\"top\">\n";

  // Search form begins here.

  echo "    <form action=\"search.php\" method=\"get\">\n";
  echo "     <table width=\"100%\" cellspacing=\"0\" summary=\"Sk efter lnkar\">\n";
  echo "      <tr><td colspan=\"3\" class=\"header\">Sk lnkar</td></tr>\n";
  echo "      <tr>\n";
  echo "       <td class=\"searchform\" style=\"text-align: right;\">Skstrng:</td>\n";
  echo "       <td colspan=\"2\" class=\"searchform\" style=\"text-align: left;\">\n";
  echo "        <input type=\"text\" name=\"searchstring\" size=\"64\"";
  if( $searching )
    echo " value=\"".$_GET['searchstring']."\"";
  echo ">\n";
  echo "       </td>\n";
  echo "      </tr>\n";
  echo "      <tr><td></td>\n";
  echo "       <td class=\"searchform\">\n";
  $checked = ( (!$searching or (strcmp($_GET['match_type'], 'and' ) == 0)) ? ' checked' : '' );
  echo "        <input type=\"radio\" name=\"match_type\" value=\"and\"$checked>".
    "&nbsp;Match&nbsp;all&nbsp;words&nbsp;(AND)<br>\n";
  $checked = ( ($searching and (strcmp($_GET['match_type'], 'or' ) == 0)) ? ' checked' : '' );
  echo "        <input type=\"radio\" name=\"match_type\" value=\"or\"$checked>".
    "&nbsp;Match&nbsp;at&nbsp;least&nbsp;one&nbsp;word&nbsp;(OR)<br>\n";
  $checked = ( ($searching and (strcmp($_GET['match_type'], 'phrase' ) == 0)) ? ' checked' : '' );
  echo "        <input type=\"radio\" name=\"match_type\" value=\"phrase\"$checked>".
    "&nbsp;Match&nbsp;the&nbsp;phrase<br>\n";
  echo "       </td>\n";
  echo "       <td class=\"searchform\">\n";
  $checked = ( ($searching and (strcmp($_GET['ud'], 'description' ) == 0)) ? ' checked' : '' );
  echo "        <input type=\"radio\" name=\"ud\" value=\"description\"$checked>".
    "&nbsp;Search&nbsp;only&nbsp;descriptions<br>\n";
  $checked = ( ($searching and (strcmp($_GET['ud'], 'url' ) == 0)) ? ' checked' : '' );
  echo "        <input type=\"radio\" name=\"ud\" value=\"url\"$checked>".
    "&nbsp;Search&nbsp;only&nbsp;urls<br>\n";
  $checked = ( (!$searching or (strcmp($_GET['ud'], 'both' ) == 0)) ? ' checked' : '' );
  echo "        <input type=\"radio\" name=\"ud\" value=\"both\"$checked>".
    "&nbsp;Search&nbsp;both&nbsp;descriptions&nbsp;and&nbsp;urls<br>\n";
  echo "       </td>\n";
  echo "      </tr>\n";
  echo "      <tr><td></td>\n";
  echo "       <td class=\"searchform\" style=\"text-align: left;\">\n";
  echo "        <input type=\"submit\" value=\"Sk\">\n";
  echo "        <input type=\"reset\" value=\"Rensa formulr\">\n";
  echo "       </td>\n";
  echo "      </tr>\n";
  echo "     </table>\n";
  echo "    </form>\n";

  // Search links begin here.

  if( $searching )
    {
      $query = "SELECT * FROM link WHERE ";

      if( strcmp($_GET['match_type'], 'phrase') == 0 )
        {
          $query .= add_in_query($_GET['searchstring']);
        }
      else
        {
          $words = explode(' ', $_GET['searchstring']);
          $query .= "(";
          $first = true;
          foreach( $words as $word )
            {
              if( $first )
                $first = false;
              else
                $query .= " ".strtoupper($_GET['match_type'])." ";
              $query .= add_in_query($word);
            }
          $query .= ")";
        }

      $query .= " ORDER BY description";

      $q_result = mysql_query( $query )
        or error("Fel vid skning i databasen.");

      $num_result = mysql_num_rows( $q_result );

      echo "     <table width=\"100%\" cellspacing=\"0\" summary=\"Resultat av tidigare skning\">\n";
      echo "      <tr><td colspan=\"6\" class=\"header\">Skresultat - $num_result lnkar funna</td></tr>\n";
      echo "      <tr><td></td></tr>\n";
      echo "      <tr>\n";
      echo "       <td class=\"searchheader\">Beskrivining</td>\n";
      echo "       <td></td>\n";
      echo "       <td class=\"searchheader\">URL</td>\n";
      echo "       <td></td>\n";
      echo "       <td colspan=\"2\" class=\"searchheader\">Tillhrande kategorier</td>\n";
      echo "      </tr>\n";

      if( $num_result == 0 )
        {
          echo "      <tr>\n";
          echo "       <td class=\"searchtlink\">Inga lnkar hittades!</td>\n";
          echo "      </tr>\n";
        }
      else
        {
          $class = 'searchtlinkfirst';
          while( $row = mysql_fetch_array( $q_result ) )
            {
              echo "      <tr>\n";
              echo "       <td class=\"$class\">".
                "<a href=\"".$row['url']."\" class=\"alink\">".
                $row['description']."</a></td>\n";
              echo "       <td class=\"$class\">&nbsp;</td>\n";
              echo "       <td class=\"$class\">".
                "<a href=\"".$row['url']."\" class=\"alink\">".
                $row['url']."</a></td>\n";
              echo "       <td class=\"$class\">&nbsp;</td>\n";

              $cat_qresult = mysql_query( "SELECT lc_category FROM link_category ".
                                          "WHERE lc_link=".$row['id'] )
                or error("Fel vid skning av kategorier till lnkar.");

              $cat_left_side = array();
              $cat_right_side = array();
              $left = false;
              while( $cat_row = mysql_fetch_array( $cat_qresult ) )
                {
                  $left = ( $left ? false : true );
                  $cat_name =
                    $category_hierarchy[ $cat_row['lc_category'] ]->get_name_with_parents();

                  if( $left )
                    $cat_left_side[ $cat_row['lc_category'] ] = $cat_name;
                  else
                    $cat_right_side[ $cat_row['lc_category'] ] = $cat_name;
                }

              echo "       <td class=\"".$class."cat\" style>\n";
              if( empty($cat_left_side) )
                {
                  echo "       &nbsp;";
                }
              else
                {
                  foreach( $cat_left_side as $cat_id => $cat_name )
                    {
                      echo "        <a href=\"$hostbase/?category=$cat_id\" ".
                        "class=\"categorylink\">$cat_name</a><br>\n";
                    }
                }
              echo "       </td>\n";

              echo "       <td class=\"".$class."cat\">\n";
              if( empty($cat_right_side) )
                {
                  echo "       &nbsp;";
                }
              else
                {
                  foreach( $cat_right_side as $cat_id => $cat_name )
                    {
                      echo "        <a href=\"?category=$cat_id\" ".
                        "class=\"categorylink\">$cat_name</a><br>\n";
                    }
                }
              echo "       </td>\n";

              echo "      </tr>\n";
              if( strcmp( $class, 'searchtlinkfirst' ) == 0 )
                $class = 'searchtlink';
            }
        }

      echo "     </table>\n";
    }

  echo "   </td>\n";
  echo "  </tr>\n";

  render_page_end();
}

?>
